# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['ComputeprofileArgs', 'Computeprofile']

@pulumi.input_type
class ComputeprofileArgs:
    def __init__(__self__, *,
                 compute_attributes: pulumi.Input[Sequence[pulumi.Input['ComputeprofileComputeAttributeArgs']]],
                 name: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a Computeprofile resource.
        :param pulumi.Input[Sequence[pulumi.Input['ComputeprofileComputeAttributeArgs']]] compute_attributes: List of compute attributes
        :param pulumi.Input[str] name: Name of the compute profile
        """
        pulumi.set(__self__, "compute_attributes", compute_attributes)
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter(name="computeAttributes")
    def compute_attributes(self) -> pulumi.Input[Sequence[pulumi.Input['ComputeprofileComputeAttributeArgs']]]:
        """
        List of compute attributes
        """
        return pulumi.get(self, "compute_attributes")

    @compute_attributes.setter
    def compute_attributes(self, value: pulumi.Input[Sequence[pulumi.Input['ComputeprofileComputeAttributeArgs']]]):
        pulumi.set(self, "compute_attributes", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the compute profile
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)


@pulumi.input_type
class _ComputeprofileState:
    def __init__(__self__, *,
                 __meta_: Optional[pulumi.Input[bool]] = None,
                 compute_attributes: Optional[pulumi.Input[Sequence[pulumi.Input['ComputeprofileComputeAttributeArgs']]]] = None,
                 name: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering Computeprofile resources.
        :param pulumi.Input[bool] __meta_: @SUMMARY Foreman representation of a compute profile.
        :param pulumi.Input[Sequence[pulumi.Input['ComputeprofileComputeAttributeArgs']]] compute_attributes: List of compute attributes
        :param pulumi.Input[str] name: Name of the compute profile
        """
        if __meta_ is not None:
            pulumi.set(__self__, "__meta_", __meta_)
        if compute_attributes is not None:
            pulumi.set(__self__, "compute_attributes", compute_attributes)
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def __meta_(self) -> Optional[pulumi.Input[bool]]:
        """
        @SUMMARY Foreman representation of a compute profile.
        """
        return pulumi.get(self, "__meta_")

    @__meta_.setter
    def __meta_(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "__meta_", value)

    @property
    @pulumi.getter(name="computeAttributes")
    def compute_attributes(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ComputeprofileComputeAttributeArgs']]]]:
        """
        List of compute attributes
        """
        return pulumi.get(self, "compute_attributes")

    @compute_attributes.setter
    def compute_attributes(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ComputeprofileComputeAttributeArgs']]]]):
        pulumi.set(self, "compute_attributes", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the compute profile
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)


class Computeprofile(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 compute_attributes: Optional[pulumi.Input[Sequence[pulumi.Input[Union['ComputeprofileComputeAttributeArgs', 'ComputeprofileComputeAttributeArgsDict']]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a Computeprofile resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[Union['ComputeprofileComputeAttributeArgs', 'ComputeprofileComputeAttributeArgsDict']]]] compute_attributes: List of compute attributes
        :param pulumi.Input[str] name: Name of the compute profile
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ComputeprofileArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a Computeprofile resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param ComputeprofileArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ComputeprofileArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 compute_attributes: Optional[pulumi.Input[Sequence[pulumi.Input[Union['ComputeprofileComputeAttributeArgs', 'ComputeprofileComputeAttributeArgsDict']]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ComputeprofileArgs.__new__(ComputeprofileArgs)

            if compute_attributes is None and not opts.urn:
                raise TypeError("Missing required property 'compute_attributes'")
            __props__.__dict__["compute_attributes"] = compute_attributes
            __props__.__dict__["name"] = name
            __props__.__dict__["__meta_"] = None
        super(Computeprofile, __self__).__init__(
            'foreman:index/computeprofile:Computeprofile',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            __meta_: Optional[pulumi.Input[bool]] = None,
            compute_attributes: Optional[pulumi.Input[Sequence[pulumi.Input[Union['ComputeprofileComputeAttributeArgs', 'ComputeprofileComputeAttributeArgsDict']]]]] = None,
            name: Optional[pulumi.Input[str]] = None) -> 'Computeprofile':
        """
        Get an existing Computeprofile resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] __meta_: @SUMMARY Foreman representation of a compute profile.
        :param pulumi.Input[Sequence[pulumi.Input[Union['ComputeprofileComputeAttributeArgs', 'ComputeprofileComputeAttributeArgsDict']]]] compute_attributes: List of compute attributes
        :param pulumi.Input[str] name: Name of the compute profile
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ComputeprofileState.__new__(_ComputeprofileState)

        __props__.__dict__["__meta_"] = __meta_
        __props__.__dict__["compute_attributes"] = compute_attributes
        __props__.__dict__["name"] = name
        return Computeprofile(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def __meta_(self) -> pulumi.Output[bool]:
        """
        @SUMMARY Foreman representation of a compute profile.
        """
        return pulumi.get(self, "__meta_")

    @property
    @pulumi.getter(name="computeAttributes")
    def compute_attributes(self) -> pulumi.Output[Sequence['outputs.ComputeprofileComputeAttribute']]:
        """
        List of compute attributes
        """
        return pulumi.get(self, "compute_attributes")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Name of the compute profile
        """
        return pulumi.get(self, "name")

